<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source to the Rust file `src/lib/maxmind_reader.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>maxmind_reader.rs.html -- source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css"><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script src="../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="shortcut icon" href="../../../favicon.ico"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../geoip_maxmind/index.html'><div class='logo-container'><img src='../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../../../settings.html"><img src="../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="doccomment">//! # maxmind_readers ( mod to get data from maxmind db)</span>
<span class="doccomment">//! </span>
<span class="doccomment">//! simple mod to create an handler for different maxmind db </span>
<span class="doccomment">//! and function to read , retrieve data</span>
<span class="doccomment">//! </span>
<span class="doccomment">//! </span>

<span class="kw">use</span> <span class="ident">maxminddb</span>::<span class="ident">geoip2</span>;
<span class="kw">use</span> <span class="ident">maxminddb</span>::<span class="ident">Reader</span>;
<span class="kw">use</span> <span class="ident">maxminddb</span>::<span class="ident">MaxMindDBError</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">net</span>::<span class="ident">IpAddr</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">string</span>::<span class="ident">ToString</span>;
<span class="kw">use</span> <span class="ident">std</span>::<span class="ident">str</span>::<span class="ident">FromStr</span>;



<span class="doccomment">/// Struct to store data from maxmind db </span>
<span class="doccomment">/// If you want to add more data you can add it there </span>
<span class="doccomment">/// modify header_data_result function</span>
<span class="doccomment">/// modify get_generic_data</span>
<span class="doccomment">/// modify </span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DataResult</span> {

    <span class="kw">pub</span> <span class="ident">ip</span> : <span class="ident">String</span>,
    <span class="kw">pub</span> <span class="ident">country</span> : <span class="ident">String</span>,
    <span class="kw">pub</span> <span class="ident">longitude</span> : <span class="ident">f64</span>,
    <span class="kw">pub</span> <span class="ident">latitude</span> : <span class="ident">f64</span>,
    <span class="kw">pub</span> <span class="ident">asn</span> : <span class="ident">u32</span>,
    <span class="kw">pub</span> <span class="ident">aso</span> : <span class="ident">String</span>,

}



<span class="doccomment">/// Return a simple structure to put on the</span>
<span class="doccomment">/// head of csv file </span>
<span class="doccomment">/// </span>
<span class="doccomment">/// In this case the return is a string</span>
<span class="doccomment">/// IP , Country , Longitude , Latitude , ASN , ASO \n</span>
<span class="doccomment">///</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">header_data_result</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">String</span> {

    <span class="ident">String</span>::<span class="ident">from</span>(<span class="string">&quot;Line , IP , Country , Longitude , Latitude , ASN , ASO \n&quot;</span>)

}


<span class="doccomment">/// Return a generic_data for country , long, lat , asn and aso</span>
<span class="doccomment">/// </span>
<span class="doccomment">/// Useful when we can t find data about certain ip </span>
<span class="doccomment">/// </span>
<span class="doccomment">/// #Arguments </span>
<span class="doccomment">///     `ip` - reference to an ip </span>
<span class="doccomment">/// </span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">get_generic_data</span>(<span class="ident">ip</span> : <span class="kw-2">&amp;</span><span class="ident">str</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">DataResult</span> {

    <span class="kw">let</span> <span class="ident">generic</span> : <span class="ident">DataResult</span> <span class="op">=</span> <span class="ident">DataResult</span> {
        <span class="ident">ip</span> : <span class="ident">String</span>::<span class="ident">from</span>(<span class="ident">ip</span>),
        <span class="ident">country</span> : <span class="ident">String</span>::<span class="ident">from</span>(<span class="string">&quot;None&quot;</span>),
        <span class="ident">longitude</span> : <span class="number">0.0</span>,
        <span class="ident">latitude</span> : <span class="number">0.0</span>,
        <span class="ident">asn</span> : <span class="number">0</span>,
        <span class="ident">aso</span> : <span class="ident">String</span>::<span class="ident">from</span>(<span class="string">&quot;None&quot;</span>),
    };

    <span class="ident">generic</span>

}


<span class="doccomment">/// Getting a string of the data in DataResult</span>
<span class="kw">impl</span> <span class="ident">ToString</span> <span class="kw">for</span> <span class="ident">DataResult</span> {

        <span class="kw">fn</span> <span class="ident">to_string</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">String</span>{

            <span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;{} , {} , {} , {} , {} , \&quot;{}\&quot;\n&quot;</span>, <span class="self">self</span>.<span class="ident">ip</span> , <span class="self">self</span>.<span class="ident">country</span>,<span class="self">self</span>.<span class="ident">longitude</span>,<span class="self">self</span>.<span class="ident">latitude</span>,<span class="self">self</span>.<span class="ident">asn</span>,<span class="self">self</span>.<span class="ident">aso</span>)

        }

}

<span class="doccomment">/// ReaderDb is a structure who save city and isp </span>
<span class="doccomment">/// handler </span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">ReaderDb</span> {

    <span class="ident">city</span> : <span class="ident">Reader</span>,
    <span class="ident">isp</span> : <span class="ident">Reader</span>,
    
}

<span class="doccomment">/// reader_db : function to get handler for city and isp database</span>
<span class="doccomment">/// </span>
<span class="doccomment">/// #Arguments</span>
<span class="doccomment">///     `path`  - Path to the database folder</span>
<span class="doccomment">/// </span>
<span class="doccomment">/// # Remarks </span>
<span class="doccomment">///     We need the path to this two differents files</span>
<span class="doccomment">///     GeoLite2-City.mmdb</span>
<span class="doccomment">///     GeoLite2-ASN.mmdb</span>
<span class="doccomment">/// You can add more database just play with the struct on this file</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">reader_db</span>( <span class="ident">path</span> : <span class="kw-2">&amp;</span><span class="ident">str</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">ReaderDb</span>,<span class="ident">String</span><span class="op">&gt;</span> {

    <span class="kw">let</span> <span class="ident">db_city_loc</span> <span class="op">=</span> <span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;{}/GeoLite2-City.mmdb&quot;</span>,<span class="ident">path</span>);
    <span class="kw">let</span> <span class="ident">db_isp_loc</span>  <span class="op">=</span> <span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;{}/GeoLite2-ASN.mmdb&quot;</span>,<span class="ident">path</span>);


    <span class="kw">let</span> <span class="ident">reader_city</span> <span class="op">=</span> <span class="ident">maxminddb</span>::<span class="ident">Reader</span>::<span class="ident">open</span>(<span class="kw-2">&amp;</span><span class="ident">db_city_loc</span>);
    <span class="kw">let</span> <span class="ident">reader_isp</span>  <span class="op">=</span> <span class="ident">maxminddb</span>::<span class="ident">Reader</span>::<span class="ident">open</span>(<span class="kw-2">&amp;</span><span class="ident">db_isp_loc</span>);


    <span class="kw">let</span> <span class="ident">city</span>  <span class="op">=</span> <span class="kw">match</span> <span class="ident">reader_city</span> {
        <span class="prelude-val">Ok</span>(<span class="ident">r</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">r</span> ,
        <span class="prelude-val">Err</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> {
            <span class="kw">match</span> <span class="ident">e</span> {
                <span class="ident">MaxMindDBError</span>::<span class="ident">AddressNotFoundError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span>  { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;AdresseNotFoundErrorCity: {}&quot;</span>,<span class="ident">e</span>)); },
                <span class="ident">MaxMindDBError</span>::<span class="ident">DecodingError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;DecodingErrorCity: {}&quot;</span>,<span class="ident">e</span>)) } , 
                <span class="ident">MaxMindDBError</span>::<span class="ident">InvalidDatabaseError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;InvalidDatabaseErrorCity: {}&quot;</span>,<span class="ident">e</span>));},
                <span class="ident">MaxMindDBError</span>::<span class="ident">IoError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span>  { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;IOErrorCity: {}&quot;</span>,<span class="ident">e</span>));},
                <span class="ident">MaxMindDBError</span>::<span class="ident">MapError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span>  { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;MapErrorCity: {}&quot;</span>,<span class="ident">e</span>));},
            }
        }

    };


    <span class="kw">let</span> <span class="ident">isp</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">reader_isp</span> {
        <span class="prelude-val">Ok</span>(<span class="ident">r</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">r</span> ,
        <span class="prelude-val">Err</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> {
            <span class="kw">match</span> <span class="ident">e</span> {
                <span class="ident">MaxMindDBError</span>::<span class="ident">AddressNotFoundError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span>  { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;AdresseNotFoundErrorIsp: {}&quot;</span>,<span class="ident">e</span>)); },
                <span class="ident">MaxMindDBError</span>::<span class="ident">DecodingError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;DecodingErrorIsp: {}&quot;</span>,<span class="ident">e</span>)); } , 
                <span class="ident">MaxMindDBError</span>::<span class="ident">InvalidDatabaseError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;InvalidDatabaseErrorIsp: {}&quot;</span>,<span class="ident">e</span>));},
                <span class="ident">MaxMindDBError</span>::<span class="ident">IoError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span>  { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;IOErrorIsp: {}&quot;</span>,<span class="ident">e</span>));},
                <span class="ident">MaxMindDBError</span>::<span class="ident">MapError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span>  { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;MapErrorIsp: {}&quot;</span>,<span class="ident">e</span>));},
            }
        }

    };

    <span class="prelude-val">Ok</span>(<span class="ident">ReaderDb</span> { <span class="ident">city</span> , <span class="ident">isp</span> })

}


<span class="kw">impl</span> <span class="ident">ReaderDb</span> {

    <span class="doccomment">/// retrive_data function to get the information we need</span>
    <span class="doccomment">/// about an ip adress </span>
    <span class="doccomment">/// if the search or bad ip , we get an error message</span>
    <span class="doccomment">/// </span>
    <span class="doccomment">/// NO PANIC is this case</span>
    <span class="doccomment">/// </span>
    <span class="doccomment">/// #Arguments </span>
    <span class="doccomment">///     `ip` - The ip we need information  about</span>
    <span class="doccomment">/// </span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">retrieve_data</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">ip</span> : <span class="kw-2">&amp;</span><span class="ident">str</span> ) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">DataResult</span>,<span class="ident">String</span><span class="op">&gt;</span>{

        <span class="comment">// should never fail if ip is checked already</span>
        <span class="kw">let</span> <span class="ident">ipstr</span> <span class="op">=</span> <span class="ident">String</span>::<span class="ident">from</span>(<span class="ident">ip</span>);
        
        <span class="kw">let</span> <span class="ident">ip</span> : <span class="ident">IpAddr</span>;
        
        <span class="kw">match</span> <span class="ident">FromStr</span>::<span class="ident">from_str</span>(<span class="kw-2">&amp;</span><span class="ident">ipstr</span>) {
            <span class="prelude-val">Ok</span>(<span class="ident">o</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">ip</span> <span class="op">=</span> <span class="ident">o</span>,
            <span class="prelude-val">Err</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;IP : {} Error =&gt; {} &quot;</span>,<span class="ident">ipstr</span>,<span class="ident">e</span>));
            }
        }

        


        <span class="kw">let</span> <span class="ident">city</span> : <span class="ident">geoip2</span>::<span class="ident">City</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">city</span>.<span class="ident">lookup</span>(<span class="ident">ip</span>){
            <span class="prelude-val">Ok</span>(<span class="ident">o</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">o</span>,
            <span class="prelude-val">Err</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">match</span> <span class="ident">e</span> {
                    <span class="ident">MaxMindDBError</span>::<span class="ident">AddressNotFoundError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span>  { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;AdresseNotFoundErrorCITYIP: {} =&gt; {}&quot;</span>,<span class="ident">e</span>,<span class="ident">ip</span>)); },
                    <span class="ident">MaxMindDBError</span>::<span class="ident">DecodingError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;DecodingErrorCITYIP: {}=&gt; {}&quot;</span>,<span class="ident">e</span>,<span class="ident">ip</span>)); } , 
                    <span class="ident">MaxMindDBError</span>::<span class="ident">InvalidDatabaseError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;InvalidDatabaseErrorCITYIP: {}=&gt; {}&quot;</span>,<span class="ident">e</span>,<span class="ident">ip</span>));},
                    <span class="ident">MaxMindDBError</span>::<span class="ident">IoError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span>  { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;IOErrorCITYIP: {}=&gt; {}&quot;</span>,<span class="ident">e</span>,<span class="ident">ip</span>));},
                    <span class="ident">MaxMindDBError</span>::<span class="ident">MapError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span>  { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;MapErrorCITYIP: {}=&gt; {}&quot;</span>,<span class="ident">e</span>,<span class="ident">ip</span>));},
                }
            },
        };

        <span class="kw">let</span> <span class="ident">isp</span> : <span class="ident">geoip2</span>::<span class="ident">Isp</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">isp</span>.<span class="ident">lookup</span>(<span class="ident">ip</span>) {
            <span class="prelude-val">Ok</span>(<span class="ident">o</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">o</span>,
            <span class="prelude-val">Err</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">match</span> <span class="ident">e</span> {
                    <span class="ident">MaxMindDBError</span>::<span class="ident">AddressNotFoundError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span>  { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;AdresseNotFoundErrorISPIP: {}=&gt; {}&quot;</span>,<span class="ident">e</span>,<span class="ident">ip</span>)); },
                    <span class="ident">MaxMindDBError</span>::<span class="ident">DecodingError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;DecodingErrorISPIP: {}=&gt; {}&quot;</span>,<span class="ident">e</span>,<span class="ident">ip</span>)); } , 
                    <span class="ident">MaxMindDBError</span>::<span class="ident">InvalidDatabaseError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span> { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;InvalidDatabaseErrorISPIP: {}=&gt; {}&quot;</span>,<span class="ident">e</span>,<span class="ident">ip</span>));},
                    <span class="ident">MaxMindDBError</span>::<span class="ident">IoError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span>  { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;IOErrorISPIP: {}=&gt; {}&quot;</span>,<span class="ident">e</span>,<span class="ident">ip</span>));},
                    <span class="ident">MaxMindDBError</span>::<span class="ident">MapError</span>(<span class="ident">e</span>) <span class="op">=</span><span class="op">&gt;</span>  { <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="macro">format</span><span class="macro">!</span>(<span class="string">&quot;MapErrorISPIP: {}=&gt; {}&quot;</span>,<span class="ident">e</span>,<span class="ident">ip</span>));},
                }
            },
        };
        

        <span class="kw">let</span> <span class="ident">country</span> : <span class="ident">String</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">city</span>.<span class="ident">country</span> {
            <span class="prelude-val">Some</span>(<span class="ident">s</span>) <span class="op">=</span><span class="op">&gt;</span> {
                <span class="kw">match</span> <span class="ident">s</span>.<span class="ident">names</span>.<span class="ident">unwrap</span>().<span class="ident">get</span>(<span class="string">&quot;en&quot;</span>) {
                    <span class="prelude-val">Some</span>(<span class="ident">s</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">String</span>::<span class="ident">from</span>(<span class="ident">s</span>),
                    <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">String</span>::<span class="ident">from</span>(<span class="string">&quot;None&quot;</span>)
                }
            },
            <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">String</span>::<span class="ident">from</span>(<span class="string">&quot;None&quot;</span>),
        };

        <span class="kw">let</span> (<span class="ident">latitude</span>,<span class="ident">longitude</span>) <span class="op">=</span> <span class="kw">match</span> <span class="ident">city</span>.<span class="ident">location</span> {
            <span class="prelude-val">Some</span>(<span class="ident">s</span>) <span class="op">=</span><span class="op">&gt;</span> {
                (<span class="ident">s</span>.<span class="ident">latitude</span>.<span class="ident">unwrap_or_else</span>(<span class="op">|</span><span class="op">|</span> <span class="number">0.0</span>),<span class="ident">s</span>.<span class="ident">longitude</span>.<span class="ident">unwrap_or_else</span>(<span class="op">|</span><span class="op">|</span> <span class="number">0.0</span>))
            },
            <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> (<span class="number">0.0</span>,<span class="number">0.0</span>),
        };

        <span class="kw">let</span> <span class="ident">asn</span><span class="op">=</span> <span class="kw">match</span> <span class="ident">isp</span>.<span class="ident">autonomous_system_number</span> {
            <span class="prelude-val">Some</span>(<span class="ident">s</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">s</span>,
            <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="number">0</span>,
        };

        <span class="kw">let</span> <span class="ident">aso</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">isp</span>.<span class="ident">autonomous_system_organization</span> {
            <span class="prelude-val">Some</span>(<span class="ident">s</span>) <span class="op">=</span><span class="op">&gt;</span> {
                <span class="ident">s</span>
            },
            <span class="prelude-val">None</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">String</span>::<span class="ident">from</span>(<span class="string">&quot;None&quot;</span>),
        };

        <span class="prelude-val">Ok</span>(<span class="ident">DataResult</span> {
            <span class="ident">ip</span> : <span class="ident">ipstr</span>,
            <span class="ident">country</span>,
            <span class="ident">longitude</span>,
            <span class="ident">latitude</span>,
            <span class="ident">asn</span>,
            <span class="ident">aso</span>,
        })

    }

}</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../";window.currentCrate = "geoip_maxmind";</script><script src="../../../aliases.js"></script><script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script><script defer src="../../../search-index.js"></script></body></html>